=== debian/changelog ===
zint (2.15.0-1) unstable; urgency=medium

  * New upstream release.
    + Install library files under multiarch location (Closes: #1060878).
  * Set libzint2.15 package as "Multi-Arch: same".

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 28 Feb 2025 22:50:03 +1100
