=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_clean:
	dh_clean
	chmod -x *.png *.desktop

#override_dh_makeshlibs:
#	dh_makeshlibs -V

execute_before_dh_auto_build:
	$(MAKE) -C docs zint.1
